﻿using HomeLibrary.Api.Entities;

namespace HomeLibrary.Api.Repositories.Contracts
{
    public interface IBookRepository
    {
        Task<IEnumerable<Book>> GetBooks();
        Task<IEnumerable<Author>> GetAuthors();
        Task<IEnumerable<Book>> GetBooksByAuthor(int authorId);
        Task<IEnumerable<Book>> GetBooksByAuthor(string authorName);
        Task<Book> GetBook(int bookId);
        Task<Author> GetAuthor(int authorId);
    }
}
